import 'dart:collection';

import 'feature_flag/feature_flag_enum.dart';
import 'feature_flag/feature_flag_helper.dart';

class MeetHourMeetingOptions {
  MeetHourMeetingOptions({
    required this.room,
  });

  final String room;
  String? serverURL;
  String? subject;
  String? token;
  String? pcode;
  bool? audioMuted;
  bool? audioOnly;
  bool? videoMuted;
  bool? prejoinPageEnabled;
  bool? disableInviteFunctions;
  String? userDisplayName;
  String? userEmail;
  String? iosAppBarRGBAColor;
  String? userAvatarURL;

  Map<String, dynamic>? webOptions; // options for web

  Map<FeatureFlagEnum, bool> featureFlags = HashMap();

  /// Get feature flags Map with keys as String instead of Enum
  /// Useful as an argument sent to the Kotlin/Swift code
  Map<String?, bool> getFeatureFlags() {
    Map<String?, bool> featureFlagsWithStrings = HashMap();

    featureFlags.forEach((key, value) {
      featureFlagsWithStrings[FeatureFlagHelper.featureFlags[key]] = value;
    });

    return featureFlagsWithStrings;
  }

  @override
  String toString() {
    return 'MeetHourMeetingOptions{room: $room, serverURL: $serverURL, '
        'subject: $subject, token: $token, pcode: $pcode, audioMuted: $audioMuted, '
        'audioOnly: $audioOnly, videoMuted: $videoMuted, prejoinPageEnabled: $prejoinPageEnabled,'
        'disableInviteFunctions: $disableInviteFunctions, userDisplayName: $userDisplayName, userEmail: $userEmail, '
        'iosAppBarRGBAColor :$iosAppBarRGBAColor, featureFlags: $featureFlags }';
  }

/* Not used yet, needs more research
  Bundle colorScheme;
  String userAvatarURL;
*/

}
